## gzuav-0.2.zip

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(gzuav C CXX)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(GNUInstallDirs)
add_definitions(-Wall)

add_subdirectory(src/ardupilot)
add_subdirectory(src/libs) # depends on ardupilot for MAVLink headers

add_subdirectory(src/gazebo)
add_subdirectory(src/gzuav)
add_subdirectory(src/gzuavchannel)
add_subdirectory(src/mavmix)

option(WITH_NS3_EXTERNAL_SYNC "Build and install ns-3 external module")
if (WITH_NS3_EXTERNAL_SYNC)
    add_subdirectory(ns-3)
endif (WITH_NS3_EXTERNAL_SYNC)

=== ns-3/CMakeLists.txt ===
# Ns-3 version we reuired to be compiled against. It must correspond to the one
# that is packaged in Ubuntu.
set(NS3VER 3.27)

# Locate ns-3's libraries
find_package(PkgConfig REQUIRED)
pkg_check_modules(NS3 REQUIRED
	libns${NS3VER}-applications
	libns${NS3VER}-core
	libns${NS3VER}-csma
	libns${NS3VER}-internet
	libns${NS3VER}-lr-wpan
	libns${NS3VER}-mobility
	libns${NS3VER}-network
	libns${NS3VER}-point-to-point
	libns${NS3VER}-stats
	libns${NS3VER}-wifi
)
add_definitions(${NS3_CFLAGS})
include_directories(${NS3_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR}/include)
link_libraries(${NS3_LIBRARIES})

# List of C++ header files comprising the external-sync module
set(HDRS
	external-sync/model/external-sync-manager.h
	external-sync/model/external-sync-simulator-impl.h
)

# List of C++ source files comprising the external-sync module
set(SRCS
	external-sync/model/external-sync-manager.cc
	external-sync/model/external-sync-simulator-impl.cc
)

# Put symlinks to our .h files in a subdiractory called "ns3", so that they can
# be included as if they were installed <ns3/filename.h>
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include/ns3)
foreach (FNAME ${HDRS})
	get_filename_component(FNAME_BASENAME ${FNAME} NAME)
	execute_process(COMMAND cmake -E create_symlink
		${CMAKE_CURRENT_SOURCE_DIR}/${FNAME}
		${CMAKE_CURRENT_BINARY_DIR}/include/ns3/${FNAME_BASENAME}
	)
endforeach (FNAME)

# Build ns-3 module
add_library(ns${NS3VER}-external-sync SHARED ${SRCS})
link_libraries(ns${NS3VER}-external-sync)

# Install ns-3 module
install(FILES ${HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ns${NS3VER}/ns3)
install(TARGETS ns${NS3VER}-external-sync DESTINATION ${CMAKE_INSTALL_LIBDIR})

# Build and install our examples too
add_executable(ns3-dev-external-sync-lan external-sync/examples/lan.cc)
add_executable(ns3-dev-external-sync-lr-wpan external-sync/examples/lr-wpan.cc)
add_executable(ns3-dev-external-sync-p2p external-sync/examples/p2p.cc)
add_executable(ns3-dev-external-sync-wifi-adhoc external-sync/examples/wifi-adhoc.cc)
add_executable(ns3-dev-external-sync-wifi external-sync/examples/wifi.cc)

install(TARGETS
	ns3-dev-external-sync-lan
	ns3-dev-external-sync-lr-wpan
	ns3-dev-external-sync-p2p
	ns3-dev-external-sync-wifi-adhoc
	ns3-dev-external-sync-wifi
	DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== ns-3/external-sync/wscript ===
# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

# def options(opt):
#     pass

# def configure(conf):
#     conf.check_nonfatal(header_name='stdint.h', define_name='HAVE_STDINT_H')

def build(bld):
    module = bld.create_ns3_module('external-sync', ['core','network','mobility'])
    module.source = [
        'helper/external-sync-helper.cc',
        'model/external-sync-manager.cc',
        'model/external-sync-simulator-impl.cc',
        ]

    module_test = bld.create_ns3_module_test_library('external-sync')
    module_test.source = [
        'test/external-sync-test-suite.cc',
        ]

    headers = bld(features='ns3header')
    headers.module = 'external-sync'
    headers.source = [
        'helper/external-sync-helper.h',
        'model/external-sync-manager.h',
        'model/external-sync-simulator-impl.h',
        ]

    if bld.env.ENABLE_EXAMPLES:
        bld.recurse('examples')

    # bld.ns3_python_bindings()

=== src/ardupilot/CMakeLists.txt ===
include(ExternalProject)

set(USE_ARDUPILOT CACHE PATH "Path to an existing ArduPilot source repository")

if(USE_ARDUPILOT)
	# Convert USE_ARDUPILOT (which could be either a relative or an absolute
	# path) to an absolute path
	get_filename_component(
		ARDUPILOT_ABSPATH
		"${USE_ARDUPILOT}" ABSOLUTE
	)

	message(STATUS "Using ArduPilot source tree: ${ARDUPILOT_ABSPATH}")

	ExternalProject_Add(ardupilot
		# Configure paths so that output files are placed in the same
		# path they would have been if the other branch had been taken
		SOURCE_DIR "${ARDUPILOT_ABSPATH}"
		BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/ardupilot/build"
		BUILD_ALWAYS 1

		# Commands
		CONFIGURE_COMMAND "${ARDUPILOT_ABSPATH}/waf" configure --top=${ARDUPILOT_ABSPATH} --out=. --board sitl
		BUILD_COMMAND "${ARDUPILOT_ABSPATH}/waf" build --top=${ARDUPILOT_ABSPATH} --out=. --target bin/arducopter
		INSTALL_COMMAND ""
	)
else(USE_ARDUPILOT)
	set(ARDUPILOT_ABSPATH "${CMAKE_CURRENT_BINARY_DIR}/ardupilot")

	ExternalProject_Add(ardupilot
		# ArduPilot source repository
		GIT_REPOSITORY https://github.com/ArduPilot/ardupilot.git
		GIT_TAG Copter-3.6.0
		GIT_SUBMODULES modules/gtest modules/mavlink modules/waf
		UPDATE_COMMAND ""

		# Build inside downloaded source directory
		SOURCE_DIR ardupilot
		BUILD_ALWAYS 1
		BUILD_IN_SOURCE 1

		# Patch ArduPilot source files with our own version
		PATCH_COMMAND bash "${CMAKE_CURRENT_SOURCE_DIR}/apply-patches.sh" safe12345678safe

		# Commands
		CONFIGURE_COMMAND ./waf configure --board sitl
		BUILD_COMMAND ./waf build --target bin/arducopter
		INSTALL_COMMAND ""
	)
endif(USE_ARDUPILOT)

install(PROGRAMS
	"${CMAKE_CURRENT_BINARY_DIR}/ardupilot/build/sitl/bin/arducopter"
	DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/gzuav/ardupilot)

install(FILES
	"${ARDUPILOT_ABSPATH}/Tools/autotest/default_params/copter.parm"
	"${ARDUPILOT_ABSPATH}/Tools/autotest/default_params/gazebo-iris.parm"
	DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/gzuav/ardupilot)

set(MAVLINK20_PATH "${CMAKE_CURRENT_BINARY_DIR}/ardupilot/build/sitl/libraries/GCS_MAVLink/include" PARENT_SCOPE)

=== src/gazebo/CMakeLists.txt ===
find_package(gazebo REQUIRED)
find_package(Protobuf REQUIRED)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${GAZEBO_CXX_FLAGS}")
include_directories(${GAZEBO_INCLUDE_DIRS})
link_directories(${GAZEBO_LIBRARY_DIRS})
link_libraries(${GAZEBO_LIBRARIES})

set(PROTOBUF_IMPORT_DIRS)
foreach(ITR ${GAZEBO_INCLUDE_DIRS})
	if(ITR MATCHES ".*gazebo-[0-9.]+$")
		set(PROTOBUF_IMPORT_DIRS "${ITR}/gazebo/msgs/proto")
	endif()
endforeach()

install(DIRECTORY models DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/gzuav/gazebo)

add_subdirectory(plugins)

=== src/gzuav/CMakeLists.txt ===
install(PROGRAMS gzuavclient DESTINATION ${CMAKE_INSTALL_BINDIR})
install(PROGRAMS gzuavcluster DESTINATION ${CMAKE_INSTALL_BINDIR})
install(PROGRAMS gzuavserver DESTINATION ${CMAKE_INSTALL_BINDIR})

file(RELATIVE_PATH
	PATH_FROM_PYTHON_MODULE_TO_PREFIX
	${CMAKE_INSTALL_FULL_DATAROOTDIR}/gzuav/gzuavlib
	${CMAKE_INSTALL_PREFIX}
)

file(RELATIVE_PATH
	PATH_FROM_PREFIX_TO_LIBEXECDIR
	${CMAKE_INSTALL_PREFIX}
	${CMAKE_INSTALL_FULL_LIBEXECDIR}
)

file(RELATIVE_PATH
	PATH_FROM_PREFIX_TO_SHAREDIR
	${CMAKE_INSTALL_PREFIX}
	${CMAKE_INSTALL_FULL_DATAROOTDIR}
)

configure_file(gzuavlib/GzUavPaths.py.in GzUavPaths.py ESCAPE_QUOTES @ONLY)

install(FILES
	# Static source files
	gzuavlib/GazeboPaths.py
	gzuavlib/StatusServer.py
	gzuavlib/WorldTemplateFiller.py

	# Dynamically generated source file
	${CMAKE_CURRENT_BINARY_DIR}/GzUavPaths.py

	DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/gzuav/gzuavlib
)

=== src/gzuavchannel/CMakeLists.txt ===
add_executable(gzuavchannel
	main.cpp
	CommandLineParser.cpp
	ExternalSyncServer.cpp
	TCPTransport.cpp
	Transport.cpp
	UDSTransport.cpp
)

target_link_libraries(gzuavchannel libs)
install(TARGETS gzuavchannel DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/gzuav)

=== src/libs/CMakeLists.txt ===
add_library(libs
	IO/Poll.cpp
	MAVLink/MAVLink.cpp
)

# We steal MAVLink v2.0 from ArduPilot
add_dependencies(libs ardupilot)
message(STATUS "Using MAVLink v2.0 headers from: ${MAVLINK20_PATH}")

target_include_directories(libs PUBLIC
	${CMAKE_CURRENT_SOURCE_DIR}
	${MAVLINK20_PATH}
)

=== src/mavmix/CMakeLists.txt ===
add_executable(mavmix
	main.cpp
)

target_link_libraries(mavmix libs)
install(TARGETS mavmix DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/gzuav)

=== ns-3/external-sync/examples/wscript ===
# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('external-sync-p2p', ['core', 'point-to-point', 'internet', 'applications', 'external-sync'])
    obj.source = 'p2p.cc'

    obj = bld.create_ns3_program('external-sync-lan', ['core', 'internet', 'applications', 'csma', 'external-sync'])
    obj.source = 'lan.cc'

    obj = bld.create_ns3_program('external-sync-wifi', ['core', 'internet', 'applications', 'csma', 'wifi', 'external-sync'])
    obj.source = 'wifi.cc'

    obj = bld.create_ns3_program('external-sync-wifi-adhoc', ['core', 'internet', 'applications', 'csma', 'wifi', 'external-sync'])
    obj.source = 'wifi-adhoc.cc'

    obj = bld.create_ns3_program('external-sync-lr-wpan', ['core', 'lr-wpan', 'stats', 'internet', 'applications', 'csma', 'external-sync'])
    obj.source = 'lr-wpan.cc'

=== src/gazebo/plugins/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Do not strip rpath in installed libraries
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# Compile "GzUav_INTERNAL.so"
add_library(GzUav_INTERNAL SHARED
	GzUavPhaseGenerator.cc
)
set_target_properties(GzUav_INTERNAL PROPERTIES PREFIX "") # no "lib" prefix

# Make subsequent plugins link and load with GzUav_INTERNAL
link_libraries(GzUav_INTERNAL)
SET(CMAKE_INSTALL_RPATH "\$ORIGIN")

# Compile "libGzUavCameraPlugin.so"
add_library(GzUavCameraPlugin SHARED
	GzUavCameraPlugin/FrameServer.cc
	GzUavCameraPlugin/GzUavCameraPlugin.cc
)
target_link_libraries(GzUavCameraPlugin PUBLIC CameraPlugin)

# Compile "libGzUavVehiclePlugin.so"
add_library(GzUavVehiclePlugin SHARED
	GzUavVehiclePlugin/common.cc
	GzUavVehiclePlugin/Gimbal.cc
	GzUavVehiclePlugin/GzUavVehiclePlugin.cc
	GzUavVehiclePlugin/PoseSampler.cc
	GzUavVehiclePlugin/Rotor.cc
)

install(TARGETS
    GzUav_INTERNAL
    GzUavCameraPlugin
    GzUavVehiclePlugin
    DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/gzuav/gazebo/plugins
)

=== debian/changelog ===
gzuav (0.2-1) unstable; urgency=medium

  * Initial Ubuntu package.

 -- Fabio D'Urso <durso@dmi.unict.it>  Mon, 19 Nov 2018 23:22:12 +0000

=== debian/control ===
Source: gzuav
Section: misc
Priority: optional
Maintainer: Fabio D'Urso <durso@dmi.unict.it>
Build-Depends: debhelper (>= 9), cmake, git, python-future, libgazebo9-dev, libns3-dev, libgsl-dev
Standards-Version: 3.9.8
Homepage: https://gzuav.dmi.unict.it

Package: gzuav
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gazebo9, ns3
Description: A Gazebo-based framework for ArduCopter multi-UAV simulation
 GzUav (from "Gazebo" and "UAV") is a framework to run multiple-UAV simulations in Gazebo.
 .
 It consists in a set of custom programs/scripts and plug-ins for other projects. In particular, it offers:
 .
 - Patches for ArduCopter 3.6.0 (which, among other things, make simulated UAVs be ready to fly much faster - 10 seconds instead of 1 minute).
 - A tool, called GzUavChannel, that helps keeping the simulation clock stricly sychronised in all programs that are part of the simulation.
 - A Gazebo plugin that works as a GzUavChannel-aware interface for ArduCopter.
 - An optional module for the Ns-3 network simulator, to synchronise its clock too. This enables integration of realistic wireless networking in the simulation.
 .
 Example programs, written in DroneKit-python, for autonomous UAV operations are also provided.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_NS3_EXTERNAL_SYNC=ON -DCMAKE_INSTALL_LIBEXECDIR=lib
